| IGLib 1.7.2 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events Macros
Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | Properties | Events | Private Member Functions | Private Attributes | Static Private Attributes | List of all members
IG.Forms.TimerControl Class Reference
Inheritance diagram for IG.Forms.TimerControl:
[legend]
Collaboration diagram for IG.Forms.TimerControl:
[legend]

## Public Member Functions
| TimerControl ()
| Constructs a timer control. More...
void | LoadDefaultSounds ()
virtual void | PlaySoundStart ()
| Plays the sound associated with clicking the start button. More...
virtual void | PlaySoundStop ()
| Plays the sound associated with clicking the stop button. More...
virtual void | PlaySoundReset ()
| Plays the sound associated with clicking the reset button. More...
virtual void | PlaySoundSecondTick ()
| Plays the sound associated with a second tick. More...
virtual void | PlaySoundMinuteBell ()
| Plays the sound associated with the whole minute switch. More...
virtual void | PlaySoundHourBell ()
| Plays the sound associated with the whole minute switch. More...
virtual void | PlaySoundAlarmCountdown ()
| Plays the sound associated with a countdown end. More...
void | ReportInfo (string message)
| Launches an info message. More...
void | ReportWarning (string message)
| Launches a warning message. More...
void | ReportError (string message)
| Launches a warning message. More...
void | UpdateDisplayFonts ()
| Updates fonts that are dependent on the main display font, according to this font. More...
void | SetDisplayFontSize (double sizeInPoints)
| Changes size of the display font. More...
void | SetDisplayFontSize (decimal sizeInPointsDecimal)
| Changes size of the display font. More...
virtual void | StopwatchStartOrStop ()
| Starts (if it is not running) or stops (if it is running) the stopwatch. More...
virtual void | StopwatchStart ()
| Starts the stopwatch. More...
virtual void | StopwatchStop ()
| Stops the stopwatch timer. More...
virtual void | CountdownStartOrStop ()
| Starts (if it is not running) or stops (if it is running) the countdown. More...
virtual void | CountdownStart ()
| Starts the countdown timer. More...
virtual void | CountdownStop ()
| Stops the countdown timer. More...

## Static Public Attributes
static int | DefaultMaxNumTimerErrorReports = 10
| Default maximal number of times a report about timer tick exception is launched. More...

## Protected Member Functions
virtual void | UpdateDisplays ()
| Updates timer's displays. More...
virtual void | UpdateSwDisplay ()
| Refreshes stopwatch's display according to elapsed time. More...
virtual void | UpdateSwControls ()
| Updates stopwatch controls according to internal properties. More...
virtual void | UpdateDisplayAppearance ()
| Updates fonts on the timer's displays. More...
virtual void | UpdateSwButtonsAppearance ()
| Updates appearance of the stopwatch buttons. More...
virtual void | OnStopwatchTimerTick ()
| Called when the timer event fires (very often, in the range of milliseconds). Raises the StopwatchTimerTick event and updates the display. More...
virtual void | StopwatchResetIt ()
| Resets the stopwatch. More...
virtual void | OnStopwatchSecondTick ()
| Called when the stopwatch seconds count reaches a whole value (seconds tick). Raises the StopwatchSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsSwSoundSecondTick). More...
virtual void | OnStopwatchMinuteBell ()
| Called when the stopwatch minutes count reaches a whole value (minutes signal). Raises the StopwatchMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsSwSoundMinuteBell). More...
virtual void | OnStopwatchHourBell ()
| Called when the stopwatch hours count reaches a whole value (hour switch signal). Raises the StopwatchHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsSwSoundHourBell). More...
virtual void | UpdateCdInitialTimeSpan ()
| Updates initial TimeSpan of the countdown in such a way that it corresponds to its initial hours, minutes, seconds, and miilliseconds. More...
virtual void | UpdateCdInitialTime ()
| Updates initial hours, minutes, seconds, and milliseconds of the countdown in such a way that they correspond to its intial TimeSpan. More...
virtual void | UpdateCdDisplay ()
| Refreshes countdown's display according to elapsed time. More...
virtual void | UpdateCdControls ()
| Updates countdown controls according to internal properties. More...
virtual void | UpdateCdButtonsAppearance ()
| Updates appearance of the stopwatch buttons. More...
virtual void | OnCountdownTimerTick ()
| Called when the timer event fires (very often, in the range of milliseconds). Raises the CountdownTimerTick event and updates the display. More...
virtual void | CountdownResetIt ()
| Resets the countdown. More...
virtual void | OnCountdownFinished ()
| Called when the countdown reaches 0 and stops counting down. Raises the CountdownFinished event and eventually plays the appropriate alarm (if not IsSilent and if IsCdSoundAlarm). More...
virtual void | OnCountdownSecondTick ()
| Called when the countdown seconds count reaches a whole value (seconds tick). Raises the CountdownSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsCdSoundSecondTick). More...
virtual void | OnCountdownMinuteBell ()
| Called when the countdown minutes count reaches a whole value (minutes signal). Raises the CountdownMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsCdSoundMinuteBell). More...
virtual void | OnCountdownHourBell ()
| Called when the countdown hours count reaches a whole value (hours signal). Raises the CountdownHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsCdSoundHourBell). More...
virtual void | UpdateClockControls ()
| Updates clock controls according to internal properties. More...
virtual void | UpdateClockButtonsAppearance ()
| Updates appearance of the clock buttons. More...
virtual void | UpdateClockDisplay ()
| Refreshes Clock's display according to the current time. More...
virtual void | OnClockTimerTick ()
| Called when the timer event fires (very often, in the range of milliseconds). Raises the ClockTimerTick event and updates the display. More...
virtual void | OnClockSecondTick ()
| Called when the clock seconds count reaches a whole value (seconds tick). Raises the ClockSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsClockSoundSecondTick). More...
virtual void | OnClockMinuteBell ()
| Called when the clock minutes count reaches a whole value (minutes signal). Raises the ClockMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsClockSoundMinuteBell). More...
virtual void | OnClockHourBell ()
| Called when the clock hours count reaches a whole value (hours signal). Raises the ClockHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsClockSoundHourBell). More...
override void | Dispose (bool disposing)
| Clean up any resources being used. More...

## Protected Attributes
SoundPlayer | _soundPlayerStart = null
SoundPlayer | _soundPlayerStop = null
SoundPlayer | _soundPlayerReset = null
SoundPlayer | _soundPlayerSecondTick = null
SoundPlayer | _soundPlayerMinuteBell = null
SoundPlayer | _soundPlayerHourBell = null
SoundPlayer | _soundPlayerAlarmCountdown = null
bool | _isStopwatchShown = true
bool | _isStopwatchMain = false
Font | _displayFont = null
TimeSpan | _swPreviousSpan
TimeSpan | _swCurrentSpan
TimeSpan | _cdPreviousRemainingSpan
TimeSpan | _cdCurrentRemainingSpan
DateTime | _clockPreviousWallclockTime
DateTime | _clockCurrentWalclockTime
bool | _isCountdownShown = true
bool | _isCountdownhMain = false
bool | _isClockRunnng = true
bool | _isClockShown = true
bool | _isClockMain = false

## Properties
IG.Lib.IReporter | Reporter`[get]`
| Gets a reporter for the current control. More...
static int | DefaultOutputLevel`[get, set]`
| Default output level for this class of objects. More...
int | OutputLevel`[get, set]`
| Current output level for the current object. More...
int | MaxPlayErrors`[get, set]`
int | NumPlayErrors`[get, set]`
virtual SoundPlayer | SoundPlayerStart`[get]`
| Gets the sound player for playing sound when a start button is pressed. Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerStop`[get]`
| Gets the sound player for playing sound when the stop button is pressed. Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerReset`[get]`
| Gets the sound player for playing sound when the resett button is pressed. Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerSecondTick`[get]`
| Gets the sound player for playing sound when another second passes (a second tick). Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerMinuteBell`[get]`
| Gets the sound player for playing sound when another minute passes (a minute bell). Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerHourBell`[get]`
| Gets the sound player for playing sound when another hour passes (a hour bell). Player is pre-laded with the appropriate sound. More...
virtual SoundPlayer | SoundPlayerAlarmCountdown`[get]`
| Gets the sound player for playing alarm when countdown finishes. Player is pre-laded with the appropriate sound. More...
virtual bool | IsSwSoundSecondTick`[get, set]`
| Whether a tick sound is switched on (launched every second when the stopwatch is running). More...
virtual bool | IsSwSoundMinuteBell`[get, set]`
| Whether a minutes bell sound is switched on (launched every minute when the stopwatch is running). More...
virtual bool | IsSwSoundHourBell`[get, set]`
| Whether a hour bell sound is switched on (launched every hour when the stopwatch is running). More...
virtual bool | IsSwSoundButtons`[get, set]`
| Whether the stopwatch's button sound is switched on (launched every time a stopwatch button with some effect is pressed, or the same effect is achieved programatically). More...
virtual bool | IsCdSoundSecondTick`[get, set]`
| Whether the countdown's tick sound is switched on (a sound launched every second when the countdown is running). More...
virtual bool | IsCdSoundMinuteBell`[get, set]`
| Whether the countdown's minute bell sound is switched on (a sound launched every minute when the countdown is running). More...
virtual bool | IsCdSoundHourBell`[get, set]`
| Whether the countdown's hpur bell sound is switched on (a sound launched every hour when the countdown is running). More...
virtual bool | IsClockSoundSecondTick`[get, set]`
| Whether the countdown's tick sound is switched on (a sound launched every second when the countdown is running). More...
virtual bool | IsClockSoundMinuteBell`[get, set]`
| Whether the countdown's minute bell sound is switched on (a sound launched every minute when the countdown is running). More...
virtual bool | IsClockSoundHourBell`[get, set]`
| Whether the countdown's hpur bell sound is switched on (a sound launched every hour when the countdown is running). More...
bool | IsRunning`[get]`
| Indicates whether the timer is currently running or not. More...
int | TimerIntervalMs`[get, set]`
| Timer interval, in Milliseconds. More...
virtual bool | IsSilent`[get, set]`
| Flag specifying whether the complete timer is in a silent mode. More...
StopWatch1 | SwStopwatch`[get]`
| Stopwatch used to measure elapsed time for the displayed stopwatch. More...
bool | IsStopwatchRunning`[get]`
| Indicates whether the countdown timer is running or not. More...
bool | IsStopwatchShown`[get, set]`
| Specifies whether the stopwatch is shown or not. More...
bool | IsStopwatchMain`[get, set]`
| Specifies whether the stopwatch is the main gadget of the three. More...
TimeSpan | StopwatchTotalTimeSpan`[get]`
| Gets the current time span measured by the stopwatch. More...
double | StopWatchTotalTime`[get]`
| Gets the current time span measured by the stopwatch. More...
Font | FontMilli`[get, set]`
| Font used in timer's displays for milliseconds. More...
Font | DisplayFont`[get, set]`
| Font used in timerr's displays. More...
double | MilliSecondsSizeRatio`[get, set]`
| Ratio between the size of millisecond digits and other digits on the stopwatch. More...
double | MinDispayFontSizeInPoints`[get, protected set]`
| Minimal size of display font, in points. More...
bool | SwShowMilliSeconds`[get, set]`
| Whether milliseconds shoulld be shown. More...
bool | SwShowHoursWhenZero`[get, set]`
Color | ColorBgTitleMain`[get, set]`
| Background color for main timer title. More...
Color | ColorFgTitleMain`[get, set]`
| Foreground color for main timer title. More...
Color | ColorBgTitle`[get, set]`
| Background color for timer title - not main. More...
Color | ColorFgTitle`[get, set]`
| Foreground color for main timer title. More...
Color | ColorBgWarning`[get, set]`
Color | ColorBgOk`[get, set]`
Color | ColorInvisible`[get]`
Color | DisplayBg`[get, protected set]`
| Display background color. More...
Color | DisplayFg`[get, protected set]`
| Display foreground color. More...
string | SwStartText`[get, set]`
| Text that is written on the stopwatch start button. More...
string | SwStopText`[get, set]`
string | SwResetText`[get, protected set]`
Color | SwStartColor`[get, protected set]`
| Background color for stopwatch start button. More...
Color | SwStopColor`[get, protected set]`
Color | SwResetColor`[get, protected set]`
| Background color for stopwatch reset button. More...
Color | ControlsFgClosed`[get, protected set]`
| Foreground color for controls opener when controls are closed. More...
Color | ControlsFgOpen`[get, protected set]`
| Foreground color for controls opener when controls are opened. More...
string | ControlsClosedText`[get, protected set]`
| Tect for controls opener when controls are closed. More...
string | ControlsOpenText`[get, protected set]`
| Tect for controls opener when controls are opened. More...
bool | IsSwControlsOpened`[get, protected set]`
| Wheether controls are opened or not. More...
int | MaxTimerErrorReports`[get, set]`
| Macimal number of times a report on exception thrown within the timer tick event can be launched. More...
int | NumTimerErrorReports`[get, set]`
| Number of times a report on exception thrown within the timer tick event has already been launched. More...
StopWatch1 | CdStopwatch`[get]`
| Stopwatch used to measure elapsed time for the displayed cowntdown. More...
bool | IsCountdownRunning`[get]`
| Indicates whether the countdown timer is running or not. More...
bool | IsCountdownShown`[get, set]`
| Specifies whether the countdown timer is shown or not. More...
bool | IsCountdownMain`[get, set]`
| Specifies whether the countdown timer is the main gadget of the three. More...
TimeSpan | CountdownTotalTimeSpan`[get]`
| Gets the current total time span measured by the countdown's stopwatch. More...
double | CountdownTotalTime`[get]`
| Gets the current time span measured by the countdown's stopwatch. More...
TimeSpan | CountdownRemainingTimeSpan`[get]`
| Gets Countdown's remaining time span. More...
double | CountdownRemainingTime`[get]`
| Returns Countdown's remaining time in seconds. More...
virtual int | CdInitialHours`[get, set]`
| Number of hours initially set in countdown. More...
virtual int | CdInitialMinutes`[get, set]`
| Number of minutes initially set in countdown. More...
virtual int | CdInitialSeconds`[get, set]`
| Number of seconds initially set in countdown. More...
virtual int | CdInitialMilliseconds`[get, set]`
| Number of milliseconds initially set in countdown. More...
virtual TimeSpan | CdInitialTimeSpan`[get, set]`
| Initial time span set in countdown. More...
bool | CdShowMilliSeconds`[get, set]`
| Whether milliseconds shoulld be shown on countdown. More...
bool | CdShowHoursWhenZero`[get, set]`
virtual bool | IsCdSoundButtons`[get, set]`
| Whether the countdown's button sound is switched on (a sound launched every time a countdown button with some effectt is pressed, or the same effect is achieved programatically). More...
virtual bool | IsCdSoundAlarm`[get, set]`
| Whether a countdown's alarm sound is switched on (launched when the countdown is finished, i.e. the countdown reachhes zero). More...
string | CdStartText`[get, set]`
| Text that is written on the stopwatch start button. More...
string | CdStopText`[get, set]`
string | CdResetText`[get, protected set]`
Color | CdStartColor`[get, protected set]`
| Background color for stopwatch start button. More...
Color | CdStopColor`[get, protected set]`
Color | CdResetColor`[get, protected set]`
bool | IsCdControlsOpened`[get, protected set]`
| Wheether controls are opened or not. More...
DateTime | WallclockTime`[get]`
| Wallclock time as it was last looked up. More...
bool | IsClockRunning`[get, protected set]`
| Whether the clock is currently running or not. More...
bool | IsClockShown`[get, set]`
| Specifies whether the clock is shown or not. More...
bool | IsClockMain`[get, set]`
| Specifies whether the clock is the main gadget of the three. More...

## Events
EventHandler | StopwatchTimerTick
| Event that is fired on each stopwatch's timer tick (very often, in the range of milliseconds). More...
EventHandler | StopwatchStarted
| Event that is fired when the stopwatch starts. More...
EventHandler | StopwatchStopped
| Event that is fired when the stopwatch stops. More...
EventHandler | StopwatchReset
| Event that is raised when the counter is reset. More...
EventHandler | StopwatchSecondTick
| Event that is fired when second count changes to a whole value (seconds tick). More...
EventHandler | StopwatchMinuteBell
| Event that is fired when minutes count changes to a whole value (minutes signal). More...
EventHandler | StopwatchHourBell
| Event that is fired when minutes count changes to a whole value (minute switch signal). More...
EventHandler | CountdownTimerTick
| Event that is fired on each countdown's timer tick (very often, in the range of milliseconds). More...
EventHandler | CountdownStarted
| Event that is fired when the countdown starts. More...
EventHandler | CountdownStopped
| Event that is fired when the countdown stops. More...
EventHandler | CountdownReset
| Event that is raised when the counter is reset. More...
EventHandler | CountdownFinished
| Event that is fired when the countdown reaches 0. More...
EventHandler | CountdownSecondTick
| Event that is fired when second count changes to a whole value (seconds tick). More...
EventHandler | CountdownMinuteBell
| Event that is fired when minutes count changes to a whole value (minutes signal). More...
EventHandler | CountdownHourBell
| Event that is fired when gours count changes to a whole value (hours signal). More...
EventHandler | ClockTimerTick
| Event that is fired on each clock's timer tick (very often, in the range of milliseconds). More...
EventHandler | ClockSecondTick
| Event that is fired when second count changes to a whole value (seconds tick). More...
EventHandler | ClockMinuteBell
| Event that is fired when minutes count changes to a whole value (minutes signal). More...
EventHandler | ClockHourBell
| Event that is fired when gours count changes to a whole value (hours signal). More...

## Private Member Functions
void | ReportSoundError (string soundDescriptor, Exception ex)
void | timer1_Tick (object sender, EventArgs e)
| Timer event handlesr, executed on every tick of thr timer. More...
void | StopWatchControl_Load (object sender, EventArgs e)
void | btnSwControls_Click (object sender, EventArgs e)
| Toggles opening/closing stopwatch's controls panel. More...
void | chkSwSilent_CheckedChanged (object sender, EventArgs e)
| Toggles silent mode. More...
void | btnSwStartStop_Click (object sender, EventArgs e)
| Start / stop button pressed. More...
void | btnSwReset_Click (object sender, EventArgs e)
void | flowPanelOuter_SizeChanged (object sender, EventArgs e)
| Fired on size change of the outer panel of the control. Currently not used, but this event can be used fo triger the appropriate actions (e.g. adjust the size) of containing controls. Now containing controls are adjusted automatically (by appropriate property setting). More...
void | fontSelectorSw_FontSelected (object sender, FontEventArgs args)
| Trigered by font selector control when a new font was selected in it. More...
void | fontSelector_Load (object sender, EventArgs e)
| Not used. More...
void | fontSelector_FontSelected (object sender, FontEventArgs args)
| When font is selected by the font selector, it sets the display font in this control to the selected font. More...
void | numFontSize_ValueChanged (object sender, EventArgs e)
void | numSwFontSize_Enter (object sender, EventArgs e)
| Selects the contents for easy changing by typing. More...
void | numSwFontSize_Click (object sender, EventArgs e)
| Selects the contents for easy changing by typing. More...
void | chkSwDisplayMilliseconds_CheckedChanged (object sender, EventArgs e)
void | chkSwDisplayHours_CheckedChanged (object sender, EventArgs e)
void | btnCdControls_Click (object sender, EventArgs e)
| Toggles between open / closed control panel for the countdown. More...
void | chkCdSilent_CheckedChanged (object sender, EventArgs e)
| Toggles silent mode. More...
void | fontSelectorCd_FontSelected (object sender, FontEventArgs args)
void | btnCdStartStop_Click (object sender, EventArgs e)
void | btnCdReset_Click (object sender, EventArgs e)
void | chkCdDisplayMilliseconds_CheckedChanged (object sender, EventArgs e)
void | chkCdDisplayHours_CheckedChanged (object sender, EventArgs e)
void | numCdFontSize_ValueChanged (object sender, EventArgs e)
void | numCdFontSize_Enter (object sender, EventArgs e)
void | numCdFontSize_Click (object sender, EventArgs e)
void | AdaptForLinux ()
| Tries to adapt control settings in such a way that crucial controls are visible in the Linux version compiled with Mono. More...
void | AdaptForWindows ()
void | menuLinux_Click (object sender, EventArgs e)
void | menuWindows_Click (object sender, EventArgs e)
void | menuMain_Opening (object sender, CancelEventArgs e)
void | menuSw_DoubleClick (object sender, EventArgs e)
| Stopwatch becomes the main gadget. More...
void | menuSw_CheckedChanged (object sender, EventArgs e)
| Hides / shows stopwatch. More...
void | menuSwMain_Click (object sender, EventArgs e)
void | menuSwShow_Click (object sender, EventArgs e)
void | menuCd_DoubleClick (object sender, EventArgs e)
void | menuCd_CheckedChanged (object sender, EventArgs e)
void | menuCdMain_Click (object sender, EventArgs e)
void | menuCdShow_Click (object sender, EventArgs e)
void | menuClock_DoubleClick (object sender, EventArgs e)
void | menuClock_CheckedChanged (object sender, EventArgs e)
void | menuClockMain_Click (object sender, EventArgs e)
void | menuClockShow_Click (object sender, EventArgs e)
void | InitializeComponent ()
| Required method for Designer support - do not modify the contents of this method with the code editor. More...

## Private Attributes
int | _outputLevel = DefaultOutputLevel
int | _maxPlayErrors = 5
bool | _isSwSoundSecondTick = true
bool | _isSwSoundMinuteBell = true
bool | _isSwSoundHourBell = true
bool | _isSwSoundButtonPressed = true
bool | _isCdSoundSecondTick = true
bool | _isCdSoundMinuteBell = true
bool | _isCdSoundHourBell = true
bool | _isClockSoundSecondTick = true
bool | _isClockSoundMinuteBell = true
bool | _isClockSoundHourBell = true
int | _timerIntervalMs = 5
bool | _isSilent = true
StopWatch1 | _swStopwatch
Font | _fontMilli = null
double | _millisecondsSizeRatio = 0.5
double | _minDispayFontSizeInPoints = 2.0
bool | _swShowMilliSeconds = true
bool | _swShowHoursWhenZero = true
| Whether hours shoulld be shown when they are zero. More...
Color | _colorBgTitleMain = Color.LightBlue
Color | _colorBgTitle = Color.Transparent
Color | _colorFgTitleMain = Color.Black
Color | _colorFgTitle = Color.Black
Color | _colorBgWarning = Color.Red
Color | _colorBgOk = Color.Green
Color | _displayBg = Color.PaleGoldenrod
Color | _displayFg = Color.SeaGreen
string | _swStartText = "Start"
string | _swStopText = "Pause"
string | _swResetText = "Reset"
Color | _swStartColor = Color.Green
Color | _swStopColor = Color.LightSalmon
| Background color for stopwatch stop button. More...
Color | _swResetColor = Color.LightSalmon
Color | _controlsFgClosed = Color.Black
Color | _controlsFgOpen = Color.Blue
string | _controlsClosedText = "▼"
string | _ontrolsOpenText = "▲"
bool | _swControlsOpen = false
int | _maxTimerErrorReports = DefaultMaxNumTimerErrorReports
int | _numTimerErrorReports = 0
StopWatch1 | _cdStopwatch
int | _cdInitialHours = 0
int | _cdInitialMinutes = 0
int | _cdInitialSecods = 0
int | _cdInitialMs = 0
TimeSpan | _cdInitialTimeSpan = new TimeSpan(0, 0, 10, 0)
bool | _cdShowMilliSeconds = true
bool | _cdShowHoursWhenZero = true
| Whether hours shoulld be shown on countdown when they are zero. More...
bool | _isCdSoundButtonPressed = true
bool | _isCdSoundAlarm = true
string | _cdStartText = "Start"
string | _cdStopText = "Pause"
string | _cdResetText = "Reset"
Color | _cdStartColor = Color.Green
Color | _cdStopColor = Color.LightSalmon
| Background color for stopwatch stop button. More...
Color | _cdResetColor = Color.LightSalmon
| Background color for countdown reset button. More...
bool | _cdControlsOpen = false
DateTime | _lastWallclockTime = DateTime.Now
System.ComponentModel.IContainer | components = null
| Required designer variable. More...
System.Windows.Forms.FlowLayoutPanel | flowSwOuter
System.Windows.Forms.FlowLayoutPanel | flowSwDisplay
System.Windows.Forms.Label | dispSwHours
System.Windows.Forms.Label | dispSwHoursSeparator
System.Windows.Forms.Label | dispSwMin
System.Windows.Forms.Label | dispSwMinSeparator
System.Windows.Forms.Label | dispSwSec
System.Windows.Forms.Button | btnSwStartStop
System.Windows.Forms.Button | btnSwReset
System.Windows.Forms.Timer | timer1
System.Windows.Forms.Button | btnSwControls
System.Windows.Forms.GroupBox | boxSwControls
System.Windows.Forms.Label | lbSwlFontSize
System.Windows.Forms.NumericUpDown | numSwFontSize
System.Windows.Forms.FlowLayoutPanel | flowSwDisplayTop
System.Windows.Forms.FlowLayoutPanel | flowSwDisplayBottom
System.Windows.Forms.Label | dispSwSecDecimalPoint
System.Windows.Forms.Label | dispSwMilliSec
System.Windows.Forms.FlowLayoutPanel | flowSwButtosLeft
System.Windows.Forms.FlowLayoutPanel | flowSwButtonsRight
System.Windows.Forms.FlowLayoutPanel | flowSwButtons
System.Windows.Forms.FlowLayoutPanel | flowSwControlsBasic
System.Windows.Forms.Button | lblSwTitle
System.Windows.Forms.FlowLayoutPanel | flowCdOuter
System.Windows.Forms.Button | lblCdTitle
System.Windows.Forms.FlowLayoutPanel | flowCdDisplay
System.Windows.Forms.FlowLayoutPanel | flowCdDisplayTop
System.Windows.Forms.Label | dispCdHours
System.Windows.Forms.Label | dispCdHoursSeparator
System.Windows.Forms.Label | dispCdMin
System.Windows.Forms.Label | dispCdMinSeparator
System.Windows.Forms.Label | dispCdSec
System.Windows.Forms.FlowLayoutPanel | flowCdDisplayMillisec
System.Windows.Forms.Label | dispCdSecDecimalPoint
System.Windows.Forms.Label | dispCdMilliSec
System.Windows.Forms.FlowLayoutPanel | flowCdButtons
System.Windows.Forms.FlowLayoutPanel | flowCdButtonsLeft
System.Windows.Forms.Button | btnCdStartStop
System.Windows.Forms.FlowLayoutPanel | flowCdButtonsRight
System.Windows.Forms.Button | btnCdReset
System.Windows.Forms.FlowLayoutPanel | flowCdControlsBasic
System.Windows.Forms.Label | lbTwlFontSize
System.Windows.Forms.NumericUpDown | numCdFontSize
System.Windows.Forms.Button | btnCdControls
System.Windows.Forms.GroupBox | boxCdControls
FontSelectorSimple | fontSelectorSw
System.Windows.Forms.CheckBox | chkSwDisplayHours
System.Windows.Forms.CheckBox | chkSwDisplayMilliseconds
System.Windows.Forms.CheckBox | chkCdDisplayMillisec
System.Windows.Forms.CheckBox | chkCdDisplayHours
FontSelectorSimple | fontSelectorCd
System.Windows.Forms.FlowLayoutPanel | flowOuter
System.Windows.Forms.Label | lblHelpOuterFlow
System.Windows.Forms.CheckBox | chkCdSilent
System.Windows.Forms.CheckBox | chkSwSilent
System.Windows.Forms.FlowLayoutPanel | flowCdDisplaySeconds
System.Windows.Forms.ContextMenuStrip | menuMain
System.Windows.Forms.ToolStripMenuItem | menuLinux
System.Windows.Forms.Button | btnDispCdTop
System.Windows.Forms.Button | btnDispCdBottom
System.Windows.Forms.Button | btnDispCdLeft
System.Windows.Forms.Button | btnDispCdRight
System.Windows.Forms.ToolStripMenuItem | menuWindows
System.Windows.Forms.ToolStripMenuItem | menuSw
System.Windows.Forms.ToolStripMenuItem | menuCd
System.Windows.Forms.ToolStripMenuItem | menuClock
System.Windows.Forms.ToolStripMenuItem | menuSwMain
System.Windows.Forms.ToolStripMenuItem | menuSwShow
System.Windows.Forms.ToolStripMenuItem | menuCdMain
System.Windows.Forms.ToolStripMenuItem | menuClockMain
System.Windows.Forms.ToolStripMenuItem | menuCdShow
System.Windows.Forms.ToolStripMenuItem | menuClockShow
System.Windows.Forms.FlowLayoutPanel | flowClockOuter
System.Windows.Forms.Button | lblClockTitle
System.Windows.Forms.FlowLayoutPanel | flowClockDisplay
System.Windows.Forms.FlowLayoutPanel | flowClockDisplayTop
System.Windows.Forms.Label | dispClockHours
System.Windows.Forms.Label | dispClockHoursSeparator
System.Windows.Forms.Label | dispClockMin
System.Windows.Forms.Label | dispClockMinSeparator
System.Windows.Forms.FlowLayoutPanel | flowClockDisplaySeconds
System.Windows.Forms.Label | dispClockSec
System.Windows.Forms.FlowLayoutPanel | flowClockDisplayMillisec
System.Windows.Forms.Label | dispClockSecDecimalPoint
System.Windows.Forms.Label | dispClockMilliSec
System.Windows.Forms.FlowLayoutPanel | flowClockButtons
System.Windows.Forms.FlowLayoutPanel | flowClockButtonsLeft
System.Windows.Forms.Button | btnClockStartStop
System.Windows.Forms.FlowLayoutPanel | flowClockButtonsRight
System.Windows.Forms.Button | btnClockReset
System.Windows.Forms.FlowLayoutPanel | flowClockControlsBasic
System.Windows.Forms.Label | lbClocklFontSize
System.Windows.Forms.NumericUpDown | numClockFontSize
System.Windows.Forms.Button | btnClockControls
System.Windows.Forms.GroupBox | boxClockControls
System.Windows.Forms.CheckBox | chkClockSilent
System.Windows.Forms.CheckBox | chkClockDisplayMillisec
FontSelectorSimple | fontSelectorClock
System.Windows.Forms.ToolStripSeparator | toolStripSeparator1
System.Windows.Forms.ToolStripMenuItem | menuOptions
System.Windows.Forms.ToolStripSeparator | toolStripSeparator2
System.Windows.Forms.ToolStripMenuItem | menuSilent
System.Windows.Forms.ToolStripMenuItem | menuMilliseconds
System.Windows.Forms.ToolStripMenuItem | menuFont
System.Windows.Forms.ToolStripMenuItem | menuSize

## Static Private Attributes
static int | _defaultOutputLevel = 0

## Constructor & Destructor Documentation

IG.Forms.TimerControl.TimerControl | ( |  | ) |
| inline

Constructs a timer control.

References IG.Lib.UtilSystem.IsLinuxOs, and IG.Lib.UtilSystem.IsWindowsOs.

## Member Function Documentation

void IG.Forms.TimerControl.LoadDefaultSounds | ( |  | ) |
| inline

void IG.Forms.TimerControl.ReportSoundError | ( | string | soundDescriptor,
|  | Exception | ex
| ) |  |
| inline private

virtual void IG.Forms.TimerControl.PlaySoundStart | ( |  | ) |
| inline virtual

Plays the sound associated with clicking the start button.

virtual void IG.Forms.TimerControl.PlaySoundStop | ( |  | ) |
| inline virtual

Plays the sound associated with clicking the stop button.

virtual void IG.Forms.TimerControl.PlaySoundReset | ( |  | ) |
| inline virtual

Plays the sound associated with clicking the reset button.

virtual void IG.Forms.TimerControl.PlaySoundSecondTick | ( |  | ) |
| inline virtual

Plays the sound associated with a second tick.

virtual void IG.Forms.TimerControl.PlaySoundMinuteBell | ( |  | ) |
| inline virtual

Plays the sound associated with the whole minute switch.

virtual void IG.Forms.TimerControl.PlaySoundHourBell | ( |  | ) |
| inline virtual

Plays the sound associated with the whole minute switch.

virtual void IG.Forms.TimerControl.PlaySoundAlarmCountdown | ( |  | ) |
| inline virtual

Plays the sound associated with a countdown end.

void IG.Forms.TimerControl.ReportInfo | ( | string | message | ) |
| inline

Launches an info message.

void IG.Forms.TimerControl.ReportWarning | ( | string | message | ) |
| inline

Launches a warning message.

void IG.Forms.TimerControl.ReportError | ( | string | message | ) |
| inline

Launches a warning message.

void IG.Forms.TimerControl.UpdateDisplayFonts | ( |  | ) |
| inline

Updates fonts that are dependent on the main display font, according to this font.

virtual void IG.Forms.TimerControl.UpdateDisplays | ( |  | ) |
| inline protected virtual

Updates timer's displays.

virtual void IG.Forms.TimerControl.UpdateSwDisplay | ( |  | ) |
| inline protected virtual

Refreshes stopwatch's display according to elapsed time.

References IG.Num.M.floor().

virtual void IG.Forms.TimerControl.UpdateSwControls | ( |  | ) |
| inline protected virtual

Updates stopwatch controls according to internal properties.

virtual void IG.Forms.TimerControl.UpdateDisplayAppearance | ( |  | ) |
| inline protected virtual

Updates fonts on the timer's displays.

virtual void IG.Forms.TimerControl.UpdateSwButtonsAppearance | ( |  | ) |
| inline protected virtual

Updates appearance of the stopwatch buttons.

void IG.Forms.TimerControl.timer1_Tick | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Timer event handlesr, executed on every tick of thr timer.

Parameters

  sender |
  e |

void IG.Forms.TimerControl.StopWatchControl_Load | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.btnSwControls_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Toggles opening/closing stopwatch's controls panel.

void IG.Forms.TimerControl.chkSwSilent_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Toggles silent mode.

void IG.Forms.TimerControl.btnSwStartStop_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Start / stop button pressed.

void IG.Forms.TimerControl.btnSwReset_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.flowPanelOuter_SizeChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Fired on size change of the outer panel of the control. Currently not used, but this event can be used fo triger the appropriate actions (e.g. adjust the size) of containing controls. Now containing controls are adjusted automatically (by appropriate property setting).

void IG.Forms.TimerControl.fontSelectorSw_FontSelected | ( | object | sender,
|  | FontEventArgs | args
| ) |  |
| inline private

Trigered by font selector control when a new font was selected in it.

References IG.Forms.FontEventArgs.Font.

void IG.Forms.TimerControl.fontSelector_Load | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Not used.

void IG.Forms.TimerControl.fontSelector_FontSelected | ( | object | sender,
|  | FontEventArgs | args
| ) |  |
| inline private

When font is selected by the font selector, it sets the display font in this control to the selected font.

Parameters

  sender | Control that raised the event.
  args | Contains the selected font.

References IG.Forms.FontEventArgs.Font.

void IG.Forms.TimerControl.SetDisplayFontSize | ( | double | sizeInPoints | ) |
| inline

Changes size of the display font.

Parameters

  sizeInPoints | New size of the display font, in points.

void IG.Forms.TimerControl.SetDisplayFontSize | ( | decimal | sizeInPointsDecimal | ) |
| inline

Changes size of the display font.

Parameters

  sizeinPointsDecimal | New size of the display font, in points.

void IG.Forms.TimerControl.numFontSize_ValueChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.numSwFontSize_Enter | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Selects the contents for easy changing by typing.

void IG.Forms.TimerControl.numSwFontSize_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Selects the contents for easy changing by typing.

void IG.Forms.TimerControl.chkSwDisplayMilliseconds_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.chkSwDisplayHours_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

virtual void IG.Forms.TimerControl.OnStopwatchTimerTick | ( |  | ) |
| inline protected virtual

Called when the timer event fires (very often, in the range of milliseconds). Raises the StopwatchTimerTick event and updates the display.

Sounds can not be assigned to this event.

virtual void IG.Forms.TimerControl.StopwatchStartOrStop | ( |  | ) |
| inline virtual

Starts (if it is not running) or stops (if it is running) the stopwatch.

virtual void IG.Forms.TimerControl.StopwatchStart | ( |  | ) |
| inline virtual

Starts the stopwatch.

Its internal stopwatch starts running and the StopwatchStarted event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsSwSoundButtons

If the stopwatch is already runninng or it has already finished, call to this function has no effect.

virtual void IG.Forms.TimerControl.StopwatchStop | ( |  | ) |
| inline virtual

Stops the stopwatch timer.

Its internal stopwatch stops running and the StopwatchStopped event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsSwSoundButtons)

If the stopwatch is paused or it has already finished, call to this function has no effect.

virtual void IG.Forms.TimerControl.StopwatchResetIt | ( |  | ) |
| inline protected virtual

Resets the stopwatch.

Its internal stopwatch stops running (if it runs) and the StopwatchReset event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsSwSoundButtons)

virtual void IG.Forms.TimerControl.OnStopwatchSecondTick | ( |  | ) |
| inline protected virtual

Called when the stopwatch seconds count reaches a whole value (seconds tick). Raises the StopwatchSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsSwSoundSecondTick).

virtual void IG.Forms.TimerControl.OnStopwatchMinuteBell | ( |  | ) |
| inline protected virtual

Called when the stopwatch minutes count reaches a whole value (minutes signal). Raises the StopwatchMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsSwSoundMinuteBell).

virtual void IG.Forms.TimerControl.OnStopwatchHourBell | ( |  | ) |
| inline protected virtual

Called when the stopwatch hours count reaches a whole value (hour switch signal). Raises the StopwatchHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsSwSoundHourBell).

virtual void IG.Forms.TimerControl.UpdateCdInitialTimeSpan | ( |  | ) |
| inline protected virtual

Updates initial TimeSpan of the countdown in such a way that it corresponds to its initial hours, minutes, seconds, and miilliseconds.

virtual void IG.Forms.TimerControl.UpdateCdInitialTime | ( |  | ) |
| inline protected virtual

Updates initial hours, minutes, seconds, and milliseconds of the countdown in such a way that they correspond to its intial TimeSpan.

References IG.Num.M.floor().

virtual void IG.Forms.TimerControl.UpdateCdDisplay | ( |  | ) |
| inline protected virtual

Refreshes countdown's display according to elapsed time.

References IG.Num.M.floor().

virtual void IG.Forms.TimerControl.UpdateCdControls | ( |  | ) |
| inline protected virtual

Updates countdown controls according to internal properties.

virtual void IG.Forms.TimerControl.UpdateCdButtonsAppearance | ( |  | ) |
| inline protected virtual

Updates appearance of the stopwatch buttons.

void IG.Forms.TimerControl.btnCdControls_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Toggles between open / closed control panel for the countdown.

Parameters

  sender |
  e |

void IG.Forms.TimerControl.chkCdSilent_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Toggles silent mode.

void IG.Forms.TimerControl.fontSelectorCd_FontSelected | ( | object | sender,
|  | FontEventArgs | args
| ) |  |
| inline private

References IG.Forms.FontEventArgs.Font.

void IG.Forms.TimerControl.btnCdStartStop_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.btnCdReset_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.chkCdDisplayMilliseconds_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.chkCdDisplayHours_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.numCdFontSize_ValueChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.numCdFontSize_Enter | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.numCdFontSize_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

virtual void IG.Forms.TimerControl.OnCountdownTimerTick | ( |  | ) |
| inline protected virtual

Called when the timer event fires (very often, in the range of milliseconds). Raises the CountdownTimerTick event and updates the display.

Sounds can not be assigned to this event.

virtual void IG.Forms.TimerControl.CountdownStartOrStop | ( |  | ) |
| inline virtual

Starts (if it is not running) or stops (if it is running) the countdown.

virtual void IG.Forms.TimerControl.CountdownStart | ( |  | ) |
| inline virtual

Starts the countdown timer.

Its internal stopwatch starts running and the CountdownStarted event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsCdSoundButtons

If the countdown is already runninng or it has already finished, call to this function has no effect.

virtual void IG.Forms.TimerControl.CountdownStop | ( |  | ) |
| inline virtual

Stops the countdown timer.

Its internal stopwatch stops running and the CountdownStopped event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsCdSoundButtons)

If the countdown is paused or it has already finished, call to this function has no effect.

virtual void IG.Forms.TimerControl.CountdownResetIt | ( |  | ) |
| inline protected virtual

Resets the countdown.

Its internal stopwatch stops running (if it runs) and the CountdownReset event is raised.

Eventually the appropriate sound is played (if not IsSilent and if IsCdSoundButtons)

virtual void IG.Forms.TimerControl.OnCountdownFinished | ( |  | ) |
| inline protected virtual

Called when the countdown reaches 0 and stops counting down. Raises the CountdownFinished event and eventually plays the appropriate alarm (if not IsSilent and if IsCdSoundAlarm).

virtual void IG.Forms.TimerControl.OnCountdownSecondTick | ( |  | ) |
| inline protected virtual

Called when the countdown seconds count reaches a whole value (seconds tick). Raises the CountdownSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsCdSoundSecondTick).

virtual void IG.Forms.TimerControl.OnCountdownMinuteBell | ( |  | ) |
| inline protected virtual

Called when the countdown minutes count reaches a whole value (minutes signal). Raises the CountdownMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsCdSoundMinuteBell).

virtual void IG.Forms.TimerControl.OnCountdownHourBell | ( |  | ) |
| inline protected virtual

Called when the countdown hours count reaches a whole value (hours signal). Raises the CountdownHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsCdSoundHourBell).

virtual void IG.Forms.TimerControl.UpdateClockControls | ( |  | ) |
| inline protected virtual

Updates clock controls according to internal properties.

virtual void IG.Forms.TimerControl.UpdateClockButtonsAppearance | ( |  | ) |
| inline protected virtual

Updates appearance of the clock buttons.

virtual void IG.Forms.TimerControl.UpdateClockDisplay | ( |  | ) |
| inline protected virtual

Refreshes Clock's display according to the current time.

virtual void IG.Forms.TimerControl.OnClockTimerTick | ( |  | ) |
| inline protected virtual

Called when the timer event fires (very often, in the range of milliseconds). Raises the ClockTimerTick event and updates the display.

Sounds can not be assigned to this event.

virtual void IG.Forms.TimerControl.OnClockSecondTick | ( |  | ) |
| inline protected virtual

Called when the clock seconds count reaches a whole value (seconds tick). Raises the ClockSecondTick event and eventually plays the appropriate "second tick" sound (if not IsSilent and if IsClockSoundSecondTick).

virtual void IG.Forms.TimerControl.OnClockMinuteBell | ( |  | ) |
| inline protected virtual

Called when the clock minutes count reaches a whole value (minutes signal). Raises the ClockMinuteBell event and eventually plays the appropriate "minutes bell" sound (if not IsSilent and if IsClockSoundMinuteBell).

virtual void IG.Forms.TimerControl.OnClockHourBell | ( |  | ) |
| inline protected virtual

Called when the clock hours count reaches a whole value (hours signal). Raises the ClockHourBell event and eventually plays the appropriate "hours bell" sound (if not IsSilent and if IsClockSoundHourBell).

void IG.Forms.TimerControl.AdaptForLinux | ( |  | ) |
| inline private

Tries to adapt control settings in such a way that crucial controls are visible in the Linux version compiled with Mono.

Problem is that Mono's implementation of WinForms is not absolutely complete reproduction of oriiginal WinForms.

void IG.Forms.TimerControl.AdaptForWindows | ( |  | ) |
| inline private

void IG.Forms.TimerControl.menuLinux_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuWindows_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuMain_Opening | ( | object | sender,
|  | CancelEventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuSw_DoubleClick | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Stopwatch becomes the main gadget.

void IG.Forms.TimerControl.menuSw_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

Hides / shows stopwatch.

void IG.Forms.TimerControl.menuSwMain_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuSwShow_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuCd_DoubleClick | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuCd_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuCdMain_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuCdShow_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuClock_DoubleClick | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuClock_CheckedChanged | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuClockMain_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

void IG.Forms.TimerControl.menuClockShow_Click | ( | object | sender,
|  | EventArgs | e
| ) |  |
| inline private

override void IG.Forms.TimerControl.Dispose | ( | bool | disposing | ) |
| inline protected

Clean up any resources being used.

Parameters

  disposing | true if managed resources should be disposed; otherwise, false.

void IG.Forms.TimerControl.InitializeComponent | ( |  | ) |
| inline private

Required method for Designer support - do not modify the contents of this method with the code editor.

## Member Data Documentation

int IG.Forms.TimerControl._defaultOutputLevel = 0
| static private

int IG.Forms.TimerControl._outputLevel = DefaultOutputLevel
| private

int IG.Forms.TimerControl._maxPlayErrors = 5
| private

SoundPlayer IG.Forms.TimerControl._soundPlayerStart = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerStop = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerReset = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerSecondTick = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerMinuteBell = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerHourBell = null
| protected

SoundPlayer IG.Forms.TimerControl._soundPlayerAlarmCountdown = null
| protected

bool IG.Forms.TimerControl._isSwSoundSecondTick = true
| private

bool IG.Forms.TimerControl._isSwSoundMinuteBell = true
| private

bool IG.Forms.TimerControl._isSwSoundHourBell = true
| private

bool IG.Forms.TimerControl._isSwSoundButtonPressed = true
| private

bool IG.Forms.TimerControl._isCdSoundSecondTick = true
| private

bool IG.Forms.TimerControl._isCdSoundMinuteBell = true
| private

bool IG.Forms.TimerControl._isCdSoundHourBell = true
| private

bool IG.Forms.TimerControl._isClockSoundSecondTick = true
| private

bool IG.Forms.TimerControl._isClockSoundMinuteBell = true
| private

bool IG.Forms.TimerControl._isClockSoundHourBell = true
| private

int IG.Forms.TimerControl._timerIntervalMs = 5
| private

bool IG.Forms.TimerControl._isSilent = true
| private

StopWatch1 IG.Forms.TimerControl._swStopwatch
| private

bool IG.Forms.TimerControl._isStopwatchShown = true
| protected

bool IG.Forms.TimerControl._isStopwatchMain = false
| protected

Font IG.Forms.TimerControl._fontMilli = null
| private

Font IG.Forms.TimerControl._displayFont = null
| protected

double IG.Forms.TimerControl._millisecondsSizeRatio = 0.5
| private

double IG.Forms.TimerControl._minDispayFontSizeInPoints = 2.0
| private

bool IG.Forms.TimerControl._swShowMilliSeconds = true
| private

bool IG.Forms.TimerControl._swShowHoursWhenZero = true
| private

Whether hours shoulld be shown when they are zero.

Color IG.Forms.TimerControl._colorBgTitleMain = Color.LightBlue
| private

Color IG.Forms.TimerControl._colorBgTitle = Color.Transparent
| private

Color IG.Forms.TimerControl._colorFgTitleMain = Color.Black
| private

Color IG.Forms.TimerControl._colorFgTitle = Color.Black
| private

Color IG.Forms.TimerControl._colorBgWarning = Color.Red
| private

Color IG.Forms.TimerControl._colorBgOk = Color.Green
| private

Color IG.Forms.TimerControl._displayBg = Color.PaleGoldenrod
| private

Color IG.Forms.TimerControl._displayFg = Color.SeaGreen
| private

string IG.Forms.TimerControl._swStartText = "Start"
| private

string IG.Forms.TimerControl._swStopText = "Pause"
| private

string IG.Forms.TimerControl._swResetText = "Reset"
| private

Color IG.Forms.TimerControl._swStartColor = Color.Green
| private

Color IG.Forms.TimerControl._swStopColor = Color.LightSalmon
| private

Background color for stopwatch stop button.

Color IG.Forms.TimerControl._swResetColor = Color.LightSalmon
| private

Color IG.Forms.TimerControl._controlsFgClosed = Color.Black
| private

Color IG.Forms.TimerControl._controlsFgOpen = Color.Blue
| private

string IG.Forms.TimerControl._controlsClosedText = "▼"
| private

string IG.Forms.TimerControl._ontrolsOpenText = "▲"
| private

bool IG.Forms.TimerControl._swControlsOpen = false
| private

TimeSpan IG.Forms.TimerControl._swPreviousSpan
| protected

TimeSpan IG.Forms.TimerControl._swCurrentSpan
| protected

TimeSpan IG.Forms.TimerControl._cdPreviousRemainingSpan
| protected

TimeSpan IG.Forms.TimerControl._cdCurrentRemainingSpan
| protected

DateTime IG.Forms.TimerControl._clockPreviousWallclockTime
| protected

DateTime IG.Forms.TimerControl._clockCurrentWalclockTime
| protected

int IG.Forms.TimerControl.DefaultMaxNumTimerErrorReports = 10
| static

Default maximal number of times a report about timer tick exception is launched.

int IG.Forms.TimerControl._maxTimerErrorReports = DefaultMaxNumTimerErrorReports
| private

int IG.Forms.TimerControl._numTimerErrorReports = 0
| private

StopWatch1 IG.Forms.TimerControl._cdStopwatch
| private

bool IG.Forms.TimerControl._isCountdownShown = true
| protected

bool IG.Forms.TimerControl._isCountdownhMain = false
| protected

int IG.Forms.TimerControl._cdInitialHours = 0
| private

int IG.Forms.TimerControl._cdInitialMinutes = 0
| private

int IG.Forms.TimerControl._cdInitialSecods = 0
| private

int IG.Forms.TimerControl._cdInitialMs = 0
| private

TimeSpan IG.Forms.TimerControl._cdInitialTimeSpan = new TimeSpan(0, 0, 10, 0)
| private

bool IG.Forms.TimerControl._cdShowMilliSeconds = true
| private

bool IG.Forms.TimerControl._cdShowHoursWhenZero = true
| private

Whether hours shoulld be shown on countdown when they are zero.

bool IG.Forms.TimerControl._isCdSoundButtonPressed = true
| private

bool IG.Forms.TimerControl._isCdSoundAlarm = true
| private

string IG.Forms.TimerControl._cdStartText = "Start"
| private

string IG.Forms.TimerControl._cdStopText = "Pause"
| private

string IG.Forms.TimerControl._cdResetText = "Reset"
| private

Color IG.Forms.TimerControl._cdStartColor = Color.Green
| private

Color IG.Forms.TimerControl._cdStopColor = Color.LightSalmon
| private

Background color for stopwatch stop button.

Color IG.Forms.TimerControl._cdResetColor = Color.LightSalmon
| private

Background color for countdown reset button.

bool IG.Forms.TimerControl._cdControlsOpen = false
| private

DateTime IG.Forms.TimerControl._lastWallclockTime = DateTime.Now
| private

bool IG.Forms.TimerControl._isClockRunnng = true
| protected

bool IG.Forms.TimerControl._isClockShown = true
| protected

bool IG.Forms.TimerControl._isClockMain = false
| protected

System.ComponentModel.IContainer IG.Forms.TimerControl.components = null
| private

Required designer variable.

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwOuter
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwDisplay
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwHours
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwHoursSeparator
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwMin
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwMinSeparator
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwSec
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnSwStartStop
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnSwReset
| private

System.Windows.Forms.Timer IG.Forms.TimerControl.timer1
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnSwControls
| private

System.Windows.Forms.GroupBox IG.Forms.TimerControl.boxSwControls
| private

System.Windows.Forms.Label IG.Forms.TimerControl.lbSwlFontSize
| private

System.Windows.Forms.NumericUpDown IG.Forms.TimerControl.numSwFontSize
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwDisplayTop
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwDisplayBottom
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwSecDecimalPoint
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispSwMilliSec
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwButtosLeft
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwButtonsRight
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwButtons
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowSwControlsBasic
| private

System.Windows.Forms.Button IG.Forms.TimerControl.lblSwTitle
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdOuter
| private

System.Windows.Forms.Button IG.Forms.TimerControl.lblCdTitle
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdDisplay
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdDisplayTop
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdHours
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdHoursSeparator
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdMin
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdMinSeparator
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdSec
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdDisplayMillisec
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdSecDecimalPoint
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispCdMilliSec
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdButtons
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdButtonsLeft
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnCdStartStop
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdButtonsRight
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnCdReset
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdControlsBasic
| private

System.Windows.Forms.Label IG.Forms.TimerControl.lbTwlFontSize
| private

System.Windows.Forms.NumericUpDown IG.Forms.TimerControl.numCdFontSize
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnCdControls
| private

System.Windows.Forms.GroupBox IG.Forms.TimerControl.boxCdControls
| private

FontSelectorSimple IG.Forms.TimerControl.fontSelectorSw
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkSwDisplayHours
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkSwDisplayMilliseconds
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkCdDisplayMillisec
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkCdDisplayHours
| private

FontSelectorSimple IG.Forms.TimerControl.fontSelectorCd
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowOuter
| private

System.Windows.Forms.Label IG.Forms.TimerControl.lblHelpOuterFlow
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkCdSilent
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkSwSilent
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowCdDisplaySeconds
| private

System.Windows.Forms.ContextMenuStrip IG.Forms.TimerControl.menuMain
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuLinux
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnDispCdTop
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnDispCdBottom
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnDispCdLeft
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnDispCdRight
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuWindows
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuSw
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuCd
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuClock
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuSwMain
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuSwShow
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuCdMain
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuClockMain
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuCdShow
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuClockShow
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockOuter
| private

System.Windows.Forms.Button IG.Forms.TimerControl.lblClockTitle
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockDisplay
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockDisplayTop
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockHours
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockHoursSeparator
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockMin
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockMinSeparator
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockDisplaySeconds
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockSec
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockDisplayMillisec
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockSecDecimalPoint
| private

System.Windows.Forms.Label IG.Forms.TimerControl.dispClockMilliSec
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockButtons
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockButtonsLeft
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnClockStartStop
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockButtonsRight
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnClockReset
| private

System.Windows.Forms.FlowLayoutPanel IG.Forms.TimerControl.flowClockControlsBasic
| private

System.Windows.Forms.Label IG.Forms.TimerControl.lbClocklFontSize
| private

System.Windows.Forms.NumericUpDown IG.Forms.TimerControl.numClockFontSize
| private

System.Windows.Forms.Button IG.Forms.TimerControl.btnClockControls
| private

System.Windows.Forms.GroupBox IG.Forms.TimerControl.boxClockControls
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkClockSilent
| private

System.Windows.Forms.CheckBox IG.Forms.TimerControl.chkClockDisplayMillisec
| private

FontSelectorSimple IG.Forms.TimerControl.fontSelectorClock
| private

System.Windows.Forms.ToolStripSeparator IG.Forms.TimerControl.toolStripSeparator1
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuOptions
| private

System.Windows.Forms.ToolStripSeparator IG.Forms.TimerControl.toolStripSeparator2
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuSilent
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuMilliseconds
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuFont
| private

System.Windows.Forms.ToolStripMenuItem IG.Forms.TimerControl.menuSize
| private

## Property Documentation

IG.Lib.IReporter IG.Forms.TimerControl.Reporter
| get

Gets a reporter for the current control.

int IG.Forms.TimerControl.DefaultOutputLevel
| static get set

Default output level for this class of objects.

int IG.Forms.TimerControl.OutputLevel
| get set private

Current output level for the current object.

Latger the value more console output is generated.

int IG.Forms.TimerControl.MaxPlayErrors
| get set protected

int IG.Forms.TimerControl.NumPlayErrors
| get set protected

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerStart
| get

Gets the sound player for playing sound when a start button is pressed. Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerStop
| get

Gets the sound player for playing sound when the stop button is pressed. Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerReset
| get

Gets the sound player for playing sound when the resett button is pressed. Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerSecondTick
| get

Gets the sound player for playing sound when another second passes (a second tick). Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerMinuteBell
| get

Gets the sound player for playing sound when another minute passes (a minute bell). Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerHourBell
| get

Gets the sound player for playing sound when another hour passes (a hour bell). Player is pre-laded with the appropriate sound.

virtual SoundPlayer IG.Forms.TimerControl.SoundPlayerAlarmCountdown
| get

Gets the sound player for playing alarm when countdown finishes. Player is pre-laded with the appropriate sound.

virtual bool IG.Forms.TimerControl.IsSwSoundSecondTick
| get set

Whether a tick sound is switched on (launched every second when the stopwatch is running).

virtual bool IG.Forms.TimerControl.IsSwSoundMinuteBell
| get set

Whether a minutes bell sound is switched on (launched every minute when the stopwatch is running).

virtual bool IG.Forms.TimerControl.IsSwSoundHourBell
| get set

Whether a hour bell sound is switched on (launched every hour when the stopwatch is running).

virtual bool IG.Forms.TimerControl.IsSwSoundButtons
| get set

Whether the stopwatch's button sound is switched on (launched every time a stopwatch button with some effect is pressed, or the same effect is achieved programatically).

virtual bool IG.Forms.TimerControl.IsCdSoundSecondTick
| get set

Whether the countdown's tick sound is switched on (a sound launched every second when the countdown is running).

virtual bool IG.Forms.TimerControl.IsCdSoundMinuteBell
| get set

Whether the countdown's minute bell sound is switched on (a sound launched every minute when the countdown is running).

virtual bool IG.Forms.TimerControl.IsCdSoundHourBell
| get set

Whether the countdown's hpur bell sound is switched on (a sound launched every hour when the countdown is running).

virtual bool IG.Forms.TimerControl.IsClockSoundSecondTick
| get set

Whether the countdown's tick sound is switched on (a sound launched every second when the countdown is running).

virtual bool IG.Forms.TimerControl.IsClockSoundMinuteBell
| get set

Whether the countdown's minute bell sound is switched on (a sound launched every minute when the countdown is running).

virtual bool IG.Forms.TimerControl.IsClockSoundHourBell
| get set

Whether the countdown's hpur bell sound is switched on (a sound launched every hour when the countdown is running).

bool IG.Forms.TimerControl.IsRunning
| get

Indicates whether the timer is currently running or not.

True is returned if either a stopwatch is running, a countdown is running, or the current time is displayed.

int IG.Forms.TimerControl.TimerIntervalMs
| get set protected

Timer interval, in Milliseconds.

virtual bool IG.Forms.TimerControl.IsSilent
| get set

Flag specifying whether the complete timer is in a silent mode.

StopWatch1 IG.Forms.TimerControl.SwStopwatch
| get protected

Stopwatch used to measure elapsed time for the displayed stopwatch.

bool IG.Forms.TimerControl.IsStopwatchRunning
| get

Indicates whether the countdown timer is running or not.

bool IG.Forms.TimerControl.IsStopwatchShown
| get set

Specifies whether the stopwatch is shown or not.

bool IG.Forms.TimerControl.IsStopwatchMain
| get set

Specifies whether the stopwatch is the main gadget of the three.

TimeSpan IG.Forms.TimerControl.StopwatchTotalTimeSpan
| get

Gets the current time span measured by the stopwatch.

double IG.Forms.TimerControl.StopWatchTotalTime
| get

Gets the current time span measured by the stopwatch.

Font IG.Forms.TimerControl.FontMilli
| get set protected

Font used in timer's displays for milliseconds.

Font IG.Forms.TimerControl.DisplayFont
| get set protected

Font used in timerr's displays.

double IG.Forms.TimerControl.MilliSecondsSizeRatio
| get set

Ratio between the size of millisecond digits and other digits on the stopwatch.

double IG.Forms.TimerControl.MinDispayFontSizeInPoints
| get protected set

Minimal size of display font, in points.

bool IG.Forms.TimerControl.SwShowMilliSeconds
| get set

Whether milliseconds shoulld be shown.

bool IG.Forms.TimerControl.SwShowHoursWhenZero
| get set

Color IG.Forms.TimerControl.ColorBgTitleMain
| get set

Background color for main timer title.

Color IG.Forms.TimerControl.ColorFgTitleMain
| get set

Foreground color for main timer title.

Color IG.Forms.TimerControl.ColorBgTitle
| get set

Background color for timer title - not main.

Color IG.Forms.TimerControl.ColorFgTitle
| get set

Foreground color for main timer title.

Color IG.Forms.TimerControl.ColorBgWarning
| get set

Color IG.Forms.TimerControl.ColorBgOk
| get set

Color IG.Forms.TimerControl.ColorInvisible
| get

Color IG.Forms.TimerControl.DisplayBg
| get protected set

Display background color.

Color IG.Forms.TimerControl.DisplayFg
| get protected set

Display foreground color.

string IG.Forms.TimerControl.SwStartText
| get set

Text that is written on the stopwatch start button.

string IG.Forms.TimerControl.SwStopText
| get set

string IG.Forms.TimerControl.SwResetText
| get protected set

Color IG.Forms.TimerControl.SwStartColor
| get protected set

Background color for stopwatch start button.

Color IG.Forms.TimerControl.SwStopColor
| get protected set

Color IG.Forms.TimerControl.SwResetColor
| get protected set

Background color for stopwatch reset button.

Color IG.Forms.TimerControl.ControlsFgClosed
| get protected set

Foreground color for controls opener when controls are closed.

Color IG.Forms.TimerControl.ControlsFgOpen
| get protected set

Foreground color for controls opener when controls are opened.

string IG.Forms.TimerControl.ControlsClosedText
| get protected set

Tect for controls opener when controls are closed.

string IG.Forms.TimerControl.ControlsOpenText
| get protected set

Tect for controls opener when controls are opened.

bool IG.Forms.TimerControl.IsSwControlsOpened
| get protected set

Wheether controls are opened or not.

int IG.Forms.TimerControl.MaxTimerErrorReports
| get set protected

Macimal number of times a report on exception thrown within the timer tick event can be launched.

int IG.Forms.TimerControl.NumTimerErrorReports
| get set protected

Number of times a report on exception thrown within the timer tick event has already been launched.

StopWatch1 IG.Forms.TimerControl.CdStopwatch
| get protected

Stopwatch used to measure elapsed time for the displayed cowntdown.

bool IG.Forms.TimerControl.IsCountdownRunning
| get

Indicates whether the countdown timer is running or not.

bool IG.Forms.TimerControl.IsCountdownShown
| get set

Specifies whether the countdown timer is shown or not.

bool IG.Forms.TimerControl.IsCountdownMain
| get set

Specifies whether the countdown timer is the main gadget of the three.

TimeSpan IG.Forms.TimerControl.CountdownTotalTimeSpan
| get

Gets the current total time span measured by the countdown's stopwatch.

double IG.Forms.TimerControl.CountdownTotalTime
| get

Gets the current time span measured by the countdown's stopwatch.

TimeSpan IG.Forms.TimerControl.CountdownRemainingTimeSpan
| get

Gets Countdown's remaining time span.

Returns

double IG.Forms.TimerControl.CountdownRemainingTime
| get

Returns Countdown's remaining time in seconds.

Returns

virtual int IG.Forms.TimerControl.CdInitialHours
| get set protected

Number of hours initially set in countdown.

virtual int IG.Forms.TimerControl.CdInitialMinutes
| get set protected

Number of minutes initially set in countdown.

virtual int IG.Forms.TimerControl.CdInitialSeconds
| get set protected

Number of seconds initially set in countdown.

virtual int IG.Forms.TimerControl.CdInitialMilliseconds
| get set protected

Number of milliseconds initially set in countdown.

virtual TimeSpan IG.Forms.TimerControl.CdInitialTimeSpan
| get set protected

Initial time span set in countdown.

bool IG.Forms.TimerControl.CdShowMilliSeconds
| get set

Whether milliseconds shoulld be shown on countdown.

bool IG.Forms.TimerControl.CdShowHoursWhenZero
| get set

virtual bool IG.Forms.TimerControl.IsCdSoundButtons
| get set

Whether the countdown's button sound is switched on (a sound launched every time a countdown button with some effectt is pressed, or the same effect is achieved programatically).

virtual bool IG.Forms.TimerControl.IsCdSoundAlarm
| get set

Whether a countdown's alarm sound is switched on (launched when the countdown is finished, i.e. the countdown reachhes zero).

string IG.Forms.TimerControl.CdStartText
| get set

Text that is written on the stopwatch start button.

string IG.Forms.TimerControl.CdStopText
| get set

string IG.Forms.TimerControl.CdResetText
| get protected set

Color IG.Forms.TimerControl.CdStartColor
| get protected set

Background color for stopwatch start button.

Color IG.Forms.TimerControl.CdStopColor
| get protected set

Color IG.Forms.TimerControl.CdResetColor
| get protected set

bool IG.Forms.TimerControl.IsCdControlsOpened
| get protected set

Wheether controls are opened or not.

DateTime IG.Forms.TimerControl.WallclockTime
| get private

Wallclock time as it was last looked up.

bool IG.Forms.TimerControl.IsClockRunning
| get protected set

Whether the clock is currently running or not.

bool IG.Forms.TimerControl.IsClockShown
| get set

Specifies whether the clock is shown or not.

bool IG.Forms.TimerControl.IsClockMain
| get set

Specifies whether the clock is the main gadget of the three.

## Event Documentation

EventHandler IG.Forms.TimerControl.StopwatchTimerTick

Event that is fired on each stopwatch's timer tick (very often, in the range of milliseconds).

This event is usually useful for debugging or for very fine control.

EventHandler IG.Forms.TimerControl.StopwatchStarted

Event that is fired when the stopwatch starts.

EventHandler IG.Forms.TimerControl.StopwatchStopped

Event that is fired when the stopwatch stops.

EventHandler IG.Forms.TimerControl.StopwatchReset

Event that is raised when the counter is reset.

EventHandler IG.Forms.TimerControl.StopwatchSecondTick

Event that is fired when second count changes to a whole value (seconds tick).

EventHandler IG.Forms.TimerControl.StopwatchMinuteBell

Event that is fired when minutes count changes to a whole value (minutes signal).

EventHandler IG.Forms.TimerControl.StopwatchHourBell

Event that is fired when minutes count changes to a whole value (minute switch signal).

EventHandler IG.Forms.TimerControl.CountdownTimerTick

Event that is fired on each countdown's timer tick (very often, in the range of milliseconds).

This event is usually usef for debugging or for very fine control.

EventHandler IG.Forms.TimerControl.CountdownStarted

Event that is fired when the countdown starts.

EventHandler IG.Forms.TimerControl.CountdownStopped

Event that is fired when the countdown stops.

EventHandler IG.Forms.TimerControl.CountdownReset

Event that is raised when the counter is reset.

EventHandler IG.Forms.TimerControl.CountdownFinished

Event that is fired when the countdown reaches 0.

EventHandler IG.Forms.TimerControl.CountdownSecondTick

Event that is fired when second count changes to a whole value (seconds tick).

EventHandler IG.Forms.TimerControl.CountdownMinuteBell

Event that is fired when minutes count changes to a whole value (minutes signal).

EventHandler IG.Forms.TimerControl.CountdownHourBell

Event that is fired when gours count changes to a whole value (hours signal).

EventHandler IG.Forms.TimerControl.ClockTimerTick

Event that is fired on each clock's timer tick (very often, in the range of milliseconds).

This event is usually usef for debugging or for very fine control.

EventHandler IG.Forms.TimerControl.ClockSecondTick

Event that is fired when second count changes to a whole value (seconds tick).

EventHandler IG.Forms.TimerControl.ClockMinuteBell

Event that is fired when minutes count changes to a whole value (minutes signal).

EventHandler IG.Forms.TimerControl.ClockHourBell

Event that is fired when gours count changes to a whole value (hours signal).

The documentation for this class was generated from the following files:

- igforms/Utilities/Timer/TimerControl.cs
- igforms/Utilities/Timer/TimerControl.Designer.cs